/* adjlist.c */
/* this program renumbers the adjacency list for NiMo data */

#include <stdio.h>

#define YES            1
#define NO             0

struct Node{int NodeNum;
            int NodeReNum;
            int NodeVisited;};

typedef struct AdjList{struct Node l;
                       struct Node r;} AdjList;

AdjList *adjlist;   /* adjlist[]  */
int nadjlist;       /* number of adjacency pairs */

int nnodes;         /* the number of nodes in the graph */


/*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>*/
main(argc,argv)
  int argc;
  char **argv;
{
  int i,j,k,l,n,min,negcnt;
  int i1,i2,i3,i4;
  char line[132];
  FILE *fd;

  if (argc < 3)
   {
    printf("Usage: (1) input file containing matrix in adjacency list form \n");
    printf("       (2) output file containing matrix in adjacency list form \n");
    printf("       (3) nadjlist \n");
    exit(1);
   } /* end if */

 printf("input file containing matrix in adjacency list form  - argv[1]=%s\n",argv[1]);
 printf("output file containing matrix in adjacency list form - argv[2]=%s\n",argv[2]);
 printf("nadjlist                                             - argv[3]=%s\n",argv[3]);

 sscanf(argv[3],"%d",&nadjlist);
 printf("\tnadjlist=|%d| \n",nadjlist);
 fflush(stdout);

 negcnt = 0;

/* allocate memory for the adjacency list */
 adjlist = (AdjList *) calloc((nadjlist+1),sizeof(AdjList));
 if (adjlist == NULL)
  {
   printf("can't allocate memory for adjlist[] \n");
   exit(1);
  } /* end if */

/* read in the sparse matrix */

 printf("read in the sparse matrix\n");
 fflush(stdout);

printf("filename=|%s| \n",argv[1]);
 fd = fopen(argv[1],"r");

 for (k=1;k<=nadjlist;k++)
  {
   fgets(line,132,fd);

printf("%d - %s ",k,line);
fflush(stdout);

   sscanf(line,"%d %d",&i1,&i2);
   if (i1 < 0) { i1 = -1 * i1; negcnt++; }
   if (i2 < 0) { i2 = -1 * i2; negcnt++; }
/*
printf("\t\t\t|%d| - (%d,\t%d)\n",k,i1,i2);
fflush(stdout);
*/
   adjlist[k].l.NodeNum = i1;
   adjlist[k].r.NodeNum = i2;

   adjlist[k].l.NodeVisited = NO;
   adjlist[k].r.NodeVisited = NO;
  } /* end for k */

 fclose(fd);

printf("\tneg count=%d - pos count=%d \n",negcnt,(nadjlist-negcnt));
fflush(stdout);

/* renumber the nodes in the graph */
printf("renumber the nodes in the graph \n");
fflush(stdout);

 for (i=1;i<=nadjlist;i++)
  {

printf(".");
if ( (i%120) == 0) printf("\n");
fflush(stdout);

   min = nadjlist*10;
   for (k=1;k<=nadjlist;k++)
    {
     if ( (adjlist[k].l.NodeNum < min) && (adjlist[k].l.NodeVisited == NO) )
       min = adjlist[k].l.NodeNum;
     if ( (adjlist[k].r.NodeNum < min) && (adjlist[k].r.NodeVisited == NO) )
       min = adjlist[k].r.NodeNum;
    } /* end for k */
   for (k=1;k<=nadjlist;k++)
    {
     if ( (adjlist[k].l.NodeNum == min) && (adjlist[k].l.NodeVisited == NO) )
      {
       adjlist[k].l.NodeReNum = i;
       adjlist[k].l.NodeVisited = YES;
      } /* end if */
     if ( (adjlist[k].r.NodeNum == min) && (adjlist[k].r.NodeVisited == NO) )
      {
       adjlist[k].r.NodeReNum = i;
       adjlist[k].r.NodeVisited = YES;
      } /* end if */
    } /* end for k */
  } /* end for i */

/* write out the sparse matrix */

printf("filename=|%s| \n",argv[2]);
 fd = fopen(argv[2],"w");

  fprintf(fd,"%d \n",nadjlist);

 i = 0;
 n = 0;
 for (k=1;k<=nadjlist;k++)
  {

printf(".");
if ( (k%120) == 0) printf("\n");
fflush(stdout);

   l = NO;
   if (adjlist[k].l.NodeReNum > n) n = adjlist[k].l.NodeReNum;
   if (adjlist[k].r.NodeReNum > n) n = adjlist[k].r.NodeReNum;
/* remove duplicates */
   for (j=1;j<=(k-1);j++)
    {
     if ( (adjlist[k].l.NodeReNum == adjlist[j].l.NodeReNum) &&
          (adjlist[k].r.NodeReNum == adjlist[j].r.NodeReNum) )
      {
       l = YES;
       break;
      } /* end if */
    } /* end for j */    
/* print the values if there are not duplicates */
/*
   if (l == NO)
    {
     fprintf(fd,"%d\t%d\t%d\t1\t%d\t%d\t%d\n",
               ++i,
               adjlist[k].l.NodeReNum,
               adjlist[k].r.NodeReNum,
               adjlist[k].l.NodeNum,
               adjlist[k].r.NodeNum,
               k);
    } /* end if */

   if (l == NO)
    {
     fprintf(fd,"%d\t%d\t%d\n",
               ++i,
               adjlist[k].l.NodeReNum,
               adjlist[k].r.NodeReNum);
    } /* end if */

  } /* end for k */
  fprintf(fd,"%d\t%d\n",n,i);

 fclose(fd);

} /* end main() */




